﻿using System.Collections.Generic;
using System.Runtime.CompilerServices;
using System;

namespace Whitebrim.BetterSteeringWheel
{
    [Serializable]
    public class SteeringWheelAdditionalData
    {
        public bool isLocked;

        public SteeringWheelAdditionalData()
        {
            isLocked = false;
        }

		public SteeringWheelAdditionalData(bool isLocked)
		{
			this.isLocked = isLocked;
		}

        public void SetData(SteeringWheelAdditionalData data)
		{
            isLocked = data.isLocked;
		}
    }

    public static class SteeringWheelExtension
    {
        private static readonly ConditionalWeakTable<SteeringWheel, SteeringWheelAdditionalData> data = 
            new ConditionalWeakTable<SteeringWheel, SteeringWheelAdditionalData>();
        public static ConditionalWeakTable<RGD_SteeringWheel, SteeringWheelAdditionalData> RGD_data = 
            new ConditionalWeakTable<RGD_SteeringWheel, SteeringWheelAdditionalData>();

        public static SteeringWheelAdditionalData GetAdditionalData(this SteeringWheel steeringWheel)
        {
            return data.GetOrCreateValue(steeringWheel);
        }

        public static void AddData(this SteeringWheel steeringWheel, SteeringWheelAdditionalData value)
		{
			try
			{
                data.Add(steeringWheel, value);
            }
			catch (Exception) { }
		}

        public static void AddData(this RGD_SteeringWheel RGD_SteeringWheel, SteeringWheelAdditionalData value)
        {
            try
            {
                RGD_data.Add(RGD_SteeringWheel, value);
            }
            catch (Exception) { }
        }
    }
}
